/*

Freely Distributable C30 Simulator Package

Copyright (c) 1996-1998 The University of Texas
All Rights Reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.

Authors: Chris Moy and Brian Evans
Version: @(#)cycle.h	1.13	01/19/98

Department of Electrical and Computer Engineering
The University of Texas, Austin, TX 78712-1084

*/

#ifndef _CYCLE_H
#define _CYCLE_H

#include "state.h"
#include "pipeline.h"

#define C30SIM_RUN_BAD_PC 0
#define C30SIM_RUN_BREAKPOINT 1
#define C30SIM_RUN_STEPS 2

inline void
C30SimUpdateProgramCounter(pipeline* pipe, state* st, uint32 pcValue) {
    /* FIXME: pipe->pc may not point to the first binary hex number */
    uint32 thePC = pcValue;
    st->pc = pipe->pci[0] = pipe->pci[1] = pipe->pc = thePC;
}

int C30SimCycle(state *, pipeline *);
void C30SimFlushPipeline(pipeline* pipe, state* st);
int C30SimRun(state *, pipeline *, int, const uint32*, int);

#endif
